#!/usr/bin/python
# -*- coding: utf-8 -*-
"""Este script borra de LDAP aquellos usuarios reservdos que no deberían haberse creado.
El script recorre todos los grupos, y para cada grupo borra los usuarios que no
deberían estár ya en él.
"""

import ldap
import sys


def get_users_uid():
    try:
	l = ldap.open("localhost")
        l.protocol_version = ldap.VERSION3
        username = "cn=admin, o=guadalinex, c=es"
        password  = "wadA15"
        l.simple_bind(username, password)           
        baseDN = "ou=People, o=guadalinex, c=es"
        searchScope = ldap.SCOPE_SUBTREE
        retrieveAttributes = None 
        searchFilter = "cn=*"
        ldap_result_id = l.search(baseDN, searchScope, searchFilter, retrieveAttributes)

        result_set = []
        result_type, result_data = l.result(ldap_result_id, 0)
        while result_data != []: 
            if result_type == ldap.RES_SEARCH_ENTRY:
                result_set.append(result_data)
            result_type, result_data = l.result(ldap_result_id, 0)

        
        result = [ele[0][1]['uid'][0] for ele in result_set]

        return result   

    except ldap.LDAPError, e:
        print e


try:
    l_usuarios_privilegiados = ['root', 'diputacion', 'cice', 'sadesi', 'delegacion', 'ftp', 'usuario', 'soporte', 'vaguada']	
    l = ldap.open("localhost")
    l.protocol_version = ldap.VERSION3
    username = "cn=admin, o=guadalinex, c=es"
    password  = "wadA15"
    l.simple_bind(username, password)           
    baseDN = "ou=Group, o=guadalinex, c=es"
    searchScope = ldap.SCOPE_SUBTREE
    retrieveAttributes = None 
    searchFilter = "cn=*"
    ldap_result_id = l.search(baseDN, searchScope, searchFilter, retrieveAttributes)

    # Obtains groups.
    result_set = []
    result_type, result_data = l.result(ldap_result_id, 0)
    while result_data != []: 
        if result_type == ldap.RES_SEARCH_ENTRY:
            result_set.append(result_data)
        result_type, result_data = l.result(ldap_result_id, 0)

    
    user_uids = get_users_uid()
    for group in result_set:
        group_id = group[0][0]
        for user in user_uids:
            try:
    		userdel = "uid=%s, ou=People, o=guadalinex, c=es" % user
		if user in l_usuarios_privilegiados: 
                	l.delete_s(userdel)
	                print "\tBorrando...: ", user
            except ldap.LDAPError:
                pass

except ldap.LDAPError, e:
    print e
        
