#!/usr/bin/python
# -*- coding: utf-8 -*-
"""Este script corrige un problema detectado en el ldap de algunos  centros
Guadalinfo.

El problema estaba en que no se añadían todos los usuarios a todos los grupos,
con lo que algunos usuarios no estaban autorizados a reproducir sonidos, montar
discos  externos, etc.

El script recorre todos los grupos, y para cada grupo añade los usuarios que no
están ya en él.
"""

import ldap
import sys


def get_users_uid():
    try:
        l = ldap.open("localhost")
        l.protocol_version = ldap.VERSION3
        username = "cn=admin, o=guadalinex, c=es"
        password  = "wadA15"
        l.simple_bind(username, password)           
        baseDN = "ou=People, o=guadalinex, c=es"
        searchScope = ldap.SCOPE_SUBTREE
        retrieveAttributes = None 
        searchFilter = "cn=*"
        ldap_result_id = l.search(baseDN, searchScope, searchFilter, retrieveAttributes)

        result_set = []
        result_type, result_data = l.result(ldap_result_id, 0)
        while result_data != []: 
            if result_type == ldap.RES_SEARCH_ENTRY:
                result_set.append(result_data)
            result_type, result_data = l.result(ldap_result_id, 0)

        
        result = [ele[0][1]['uid'][0] for ele in result_set]

        return result   

    except ldap.LDAPError, e:
        print e


try:
    l = ldap.open("localhost")
    l.protocol_version = ldap.VERSION3
    username = "cn=admin, o=guadalinex, c=es"
    password  = "wadA15"
    l.simple_bind(username, password)           
    baseDN = "ou=Group, o=guadalinex, c=es"
    searchScope = ldap.SCOPE_SUBTREE
    retrieveAttributes = None 
    searchFilter = "cn=*"
    ldap_result_id = l.search(baseDN, searchScope, searchFilter, retrieveAttributes)

    # Obtains groups.
    result_set = []
    result_type, result_data = l.result(ldap_result_id, 0)
    while result_data != []: 
        if result_type == ldap.RES_SEARCH_ENTRY:
            result_set.append(result_data)
        result_type, result_data = l.result(ldap_result_id, 0)

    
    user_uids = get_users_uid()
    for group in result_set:
        group_id = group[0][0]
        print "Grupo:", group[0][1]['cn'][0]
        for user in user_uids:
            try:
                l.modify_s(group_id, [(ldap.MOD_ADD, 'memberUid', user)])
                print "\tAñadiendo: ", user
            except ldap.LDAPError:
                pass

except ldap.LDAPError, e:
    print e
        
