#!/usr/bin/python
# -*- coding: utf-8 -*-
'''Script que parsea el fichero xorg.conf 
para el correcto funcionamiento del servidor X
en centros guadalinfo
'''

import re
import sys
import string
import os.path

def openFile(fileIn):
    confFile = open(fileIn)
    fileContent = confFile.read()
    oldFile = open("%s.old"%fileIn,"w")
    oldFile.write(fileContent)
    oldFile.close()
    confFile.close()

    return fileContent

def parseSections(content, fileOut):
   newLines = ['\tHorizSync\t\t28-51', '\tVertRefresh\t\t43-75',\
                '\tModeline\t\t"1024x768" 70.00  1024 1064 1152 1304 768  768  770  800',
                '\tModeline\t\t"1024x768" 60.00  1024 1056 1128 1264 768  768  770  796',
                '\tModeline\t\t"1024x768" 65.00  1024 1056 1136 1288 768  768  770  796',
                '\tModeline\t\t"1024x768" 75.00 1024 1064 1160 1328  768  768  770  801']
      
   
   if content.find(newLines[4]) == -1:
    
        lines = content.splitlines()
        newFileContent = []

        for line in lines:
            
            if re.search('.*Option.*"DPMS".*', line):
                newFileContent.append(line + '\n')
                for l in newLines:
                    newFileContent.append(l + '\n')
            
            elif re.search('\tModes',line):
                resolutions = line.split('\t')[-1:][0].split(' ')
                pos = resolutions.index('"1024x768"')
                resolutions = resolutions[-(len(resolutions)-pos):]
                newLine = '\t\tModes\t\t' + string.join(resolutions,' ')
                newFileContent.append(newLine + '\n')
            elif re.search('HorizSync',line) or re.search('VertRefresh',line):
                pass
            elif re.search('Modeline',line):
                pass
            else:
                newFileContent.append(line + '\n')
                
        newFile = open(fileOut,"w")
        newFile.writelines(newFileContent)
        print "------------------------------------"
        print "Fichero de configuración actualizado"
        print "------------------------------------"   
        newFile.close()
        
   else:
        print 'El fichero de configuración es correcto'

if __name__=='__main__':
    confFile = '/etc/X11/xorg.conf'
    fContent = openFile(confFile)
    parseSections(fContent, confFile)

         
   
    
